#ifndef BLAST_AUDIO_AUDIOPCMRESOURCE_H
#define BLAST_AUDIO_AUDIOPCMRESOURCE_H

#include "Blast/Audio/IAudioResource.h"
#include "vorbis/vorbisfile.h"


namespace Blast
{
	namespace Audio
	{
		/// OggVorbisێNX
		class AudioOggResource : public Blast::Audio::IAudioResource
		{
		public:
			//====================================================================================================
			// Operation
			//----------------------------------------------------------------------------------------------------

			/// RXgN^
			AudioOggResource();

			/// fXgN^
			virtual ~AudioOggResource();


			/// V[Nʒu擪ɐݒ
			void SeekStart();


			/// NA
			virtual void Clear();


			/// ǂ擾
			virtual bool IsReadyOk() const;


			/// t@C擾
			virtual const TCHAR* GetFileName() const;

			/// `l擾
			virtual unsigned GetChannelCount() const;

			/// TvO[g擾
			virtual unsigned GetSamplingRate() const;

			/// rbg[g擾
			virtual unsigned GetBitRate() const;


			/// N[쐬
			virtual SP<IAudioResource> Clone();


			/// OggVorbist@C擾
			const OggVorbis_File& GetOggVorbisFileRef() const;

			/// OggVorbist@C擾
			OggVorbis_File& GetOggVorbisFileRef();

		protected:
			/// ǂ
			bool mIsReadyOk;


			/// t@C
			tstring mFileNameStr;

			/// `l
			unsigned mChannelCount;

			/// TvO[g
			unsigned mSamplingRate;

			/// rbg[g
			unsigned mBitRate;

			
			/// OggVorbist@C
			OggVorbis_File mOggVorbisFile;
		};

	} // namespace Audio
} // namespace Blast


#endif // BLAST_AUDIO_AUDIOPCMRESOURCE_H