#ifndef BLAST_GRAPHIC_BTMODELDX9_H
#define BLAST_GRAPHIC_BTMODELDX9_H

#include "Blast/Base/RenderableGameComponent.h"
#include "Blast/Graphic/IModel.h"
#include "Blast/Graphic/IMesh.h"
#include "Blast/Graphic/SkeletonContainer.h"
#include "Blast/Graphic/DirectX9/ShaderEffectDX9.h"
#include "Blast/Math/WorldProperty.h"


namespace Blast
{
	namespace Graphic
	{
		/// ėpfNX
		class BtModelDX9 :
			public Blast::Base::RenderableGameComponent,
			public Blast::Graphic::IModel
		{
		public:
			//====================================================================================================
			// Operation
			//----------------------------------------------------------------------------------------------------

			/// RXgN^
			BtModelDX9();

			/// fXgN^
			virtual ~BtModelDX9();


			/// XV
			virtual void Update(float);

			/// `
			virtual void Render();


			/// gk擾
			virtual const Blast::Math::Vector3& GetScaleRef() const;

			/// gkݒ
			virtual void SetScale(const Blast::Math::Vector3&);

			/// gk
			virtual void Scaling(const Blast::Math::Vector3&);


			/// ʒu擾
			virtual const Blast::Math::Vector3& GetPositionRef() const;

			/// ʒuݒ
			virtual void SetPosition(const Blast::Math::Vector3&);

			/// ړ
			virtual void Move(const Blast::Math::Vector3&);


			/// ]擾
			virtual const Blast::Math::Vector3& GetRotationRef() const;

			/// ]ݒ
			virtual void SetRotation(const Blast::Math::Vector3&);

			/// ]
			virtual void Rotate(const Blast::Math::Vector3&);


			/// J擾
			virtual SP<Blast::Graphic::ICamera> GetCamera();

			/// Jݒ
			virtual void SetCamera(SP<Blast::Graphic::ICamera>);


			/// eNjbNݒ
			virtual void SetTechnique(int);
			
			/// eNjbNݒ
			virtual void SetTechnique(const TCHAR*);


			/// Aj[VύX
			virtual void ChangeAnimation(int);

			/// Aj[VύX
			virtual void ChangeAnimation(const TCHAR*);


			/// bVǂݍ
			virtual bool LoadMesh(const TCHAR* kPFullPath);


			/// Aj[V̓ǂݍ
			virtual bool LoadAnimation(const TCHAR* kPFullPath);

			/// Aj[VJ
			virtual void ReleaseAnimation();
			
		private:
			/// [h
			Blast::Math::WorldProperty mWorldProperty;

			/// J
			SP<Blast::Graphic::ICamera> mPCamera;


			/// bV
			SP<Blast::Graphic::IMesh> mPMesh;

			/// MEMO:FBXw肵Ă܂Ă܂B
			/// XPgRei
			Blast::Graphic::SkeletonContainer mSkeletons;
		};
	} // namespace Graphic
} // namespace Blast

#endif // BLAST_GRAPHIC_BTMODELDX9_H