#include "Blast/Math/GaussJordan.h"

#include <math.h>

using namespace Blast::Math;


//====================================================================================================
// Operation
//----------------------------------------------------------------------------------------------------

/// RXgN^
GaussJordan::GaussJordan()
{
}

/// fXgN^
GaussJordan::~GaussJordan()
{
}

/// A܂
template < class T >
bool GaussJordan::Solve(int dimension, T matrix[stKDimension][stKDimension], T values[stKDimension])
{
	// MEMO:0Zɑ΂鏈Kvł



	// Ń[v
	for (int rowIndex = 0; rowIndex < dimension; ++rowIndex)
	{
		int pivotRowIndex = 0;
		int rows[stKDimension] = { 0 };

		// őlT
		double big = 0;
		for (int i = rowIndex; i < dimension; ++i)
		{
			// ΒlŌ
			double absValue = abs(matrix[i][rowIndex]);
			if (big < absValue)
			{
				big = absValue;
				pivotRowIndex = i;
			}
		}

		// ől0Ȃ
		if (big == 0)
		{
			// ُԂ܂
			return false;
		}

		rows[rowIndex] = pivotRowIndex;




		// ől̂񂪁A݌vZ̍sł͂ȂȂ
		if (rowIndex != pivotRowIndex)
		{
			// MEMO:s̃Xbvs܂

			for (int i = 0; i < dimension; ++i)
			{
				T temp = matrix[rowIndex][i];
				matrix[rowIndex][i] = matrix[pivotRowIndex][i];
				matrix[pivotRowIndex][i] = temp;
			}
			
			T temp = values[rowIndex];
			values[rowIndex] = values[pivotRowIndex];
			values[pivotRowIndex] = temp;
		}




		// W
		T coefficient = matrix[rowIndex][rowIndex];
		T invCoefficient = static_cast<T>(1.0 / coefficient);

		// s{bgs̏
		for (int i = 0; i < dimension; ++i)
		{
			matrix[rowIndex][i] *= invCoefficient;
		}

		values[rowIndex] *= invCoefficient;





		// s{bg̏
		for (int i = 0; i < dimension; ++i)
		{
			if (i != rowIndex)
			{
				T temp = matrix[i][rowIndex];
				for (int j = 0; j < dimension; ++j)
				{
					matrix[i][j] -= temp * matrix[rowIndex][j];
				}

				values[i] -= temp * values[rowIndex];
			}
		}
	}

	return true;
}

/// ev[g֐̖
template bool GaussJordan::Solve< float >(int dimension, float matrix[][GaussJordan::stKDimension], float values[]);
template bool GaussJordan::Solve< double >(int dimension, double matrix[][GaussJordan::stKDimension], double values[]);